#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

//int r;
//void add(int&x,int y)
//{
//    int p=1;
//    while(p<=x)
//        p*=10;
//    r=p*y;
//    x+=p*y;
//}

signed main()
{
    vector <int> a;
    //a.push_back(-1);
    for (int i=0; i<10; i++)
        a.push_back(i);
    string s;
    getline(cin,s);
    for (int i=0; i<s.size(); i+=2)
        a.erase(find(a.begin(),a.end(),int(s[i]-'0')));
    int l;
    cin>>l;
    if (a[0]==0)
    {
    //add(l,a[1]);
    int q=a.size();
    int q0=1;
    int ans=0;
    while(l>0)
    {
        ans+=q0*((find(a.begin(),a.end(),l%10))-a.begin());
        l/=10;
        q0*=q;
    }
    cout<<ans;
    }
    else
    {
    int q=a.size();
    int q0=1;
    int ans=0;
    while(l>0)
    {
        ans+=q0*((find(a.begin(),a.end(),l%10))-a.begin()+1);
        l/=10;
        q0*=q;
    }
    cout<<ans-1;
    }
}
